
#include "IoT-02_pinout.h"
#include "IoT-02_common.h"

#include "IoT-02_oled.h"
SSD1306  display(0x3c, I2C_SDA, I2C_SCL);
#include "WiFi.h"

void setup()
{
  Wire.begin(I2C_SDA, I2C_SCL);
  vSetupIO();
  vSetupScreen();
  Serial.begin(115200);
  Serial.println(__FILE__);

  // Set WiFi to station mode and disconnect from an AP if it was previously connected
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);

  Serial.println("Setup done");
}

void loop() {
  String sLine;
  Serial.println("scan start");

  // WiFi.scanNetworks will return the number of networks found
  int n = WiFi.scanNetworks();
  Serial.println("scan done");
  display.clear();
  display.setTextAlignment(TEXT_ALIGN_LEFT);
  display.setFont(ArialMT_Plain_16);
  display.drawString(0, 7, "SSID trobades:");
  display.setFont(ArialMT_Plain_24);
  display.drawString(0, 25, String(n));
  display.display();
  delay(1000);
  display.clear();
  display.setTextAlignment(TEXT_ALIGN_LEFT);
  display.setFont(ArialMT_Plain_10);
  if (n == 0) {
    Serial.println("no networks found");
    display.drawString(0, 10, "No networks found");
  } else {
    Serial.print(n);
    Serial.println(" networks found");
    for (int i = 0; i < n; ++i) {
      // Print SSID and RSSI for each network found
      Serial.print(i + 1);
      Serial.print(": ");
      Serial.print(WiFi.SSID(i));
      Serial.print(" (");
      Serial.print(WiFi.RSSI(i));
      Serial.print(")");
      Serial.print(" [channel: ");
      Serial.print(WiFi.channel(i));
      Serial.print("] ");
      Serial.println((WiFi.encryptionType(i) == WIFI_AUTH_OPEN) ? " " : "*");
      
      //sLine = String(WiFi.SSID(i))+"("+String(WiFi.RSSI(i))+") c:"+String(WiFi.channel(i))+(WiFi.encryptionType(i) == WIFI_AUTH_OPEN) ? " " : "*";
      sLine = /*String(i)+") "+*/String(WiFi.SSID(i))+"("+String(WiFi.RSSI(i))+")c"+String(WiFi.channel(i));
      sLine += (WiFi.encryptionType(i) == WIFI_AUTH_OPEN) ? " " : "*";
      if(i < 7){
        Serial.println(sLine);
        display.drawString(0, i*10, sLine);
      }

      delay(10);
    }
  }
  display.display();
  Serial.println("");

  // Wait a bit before scanning again
  delay(4000);
}
